public with sharing class FII_LCC_ContractingServPointServer {
  /*
   * @Author			LDLP
   * @Email			ldelara@deloitte.es
   * @Vendor			Deloitte
   * @Version			V0.1
   * @DateCreated		2018/07/25
   * @LastChange		2018/07/25	LDLP: Inital Version - {This method calls the webservice that queries SVE by passing it a string with the CUPS code.}
   */

  @AuraEnabled
  public static String callSVEPS(String cups) {
    adaptadorSVEWS contextWS = new adaptadorSVEWS();
    string emptycups = cups.deleteWhitespace();
    return contextWS.requestBySupplyPointTBCCEX028(emptycups, '');
  }

  /*
   * @Author			MR
   * @Email			manrivero@deloitte.es
   * @Vendor			Deloitte
   * @Version			V0.1
   * @DateCreated		2019/01/24
   * @LastChange		2019/01/24	MR: Inital Version - {This method check that Service Point belongs to a valid distributor.}
   */

  @AuraEnabled
  public static Boolean checkDistributor(String cups, String bussinesLine) {
    Boolean check = true;
    if (cups != 'PENDIENTE_INFORMAR' && cups != '') {
      List<Distribution_Group__mdt> distributorList = new List<Distribution_Group__mdt>();
      String cups6 = cups.substring(0, 6);
      String cups8 = cups.substring(0, 8);
      if (Schema.sObjectType.Distribution_Group__mdt.isAccessible()) {
        distributorList = [
          SELECT CUPS__c
          FROM Distribution_Group__mdt
          WHERE
            CUPS__c LIKE :'%' + cups8 + '%'
            AND Business_line__c = :bussinesLine
        ];
        if (distributorList.size() == 0) {
          distributorList = [
            SELECT CUPS__c
            FROM Distribution_Group__mdt
            WHERE
              CUPS__c LIKE :'%' + cups6 + '%'
              AND Business_line__c = :bussinesLine
          ];
        }
      }
      if (distributorList.size() == 0) {
        check = false;
      }
    }
    return check;
  }

  /* With this method you can get the Id of a record type giving the Object name and the developer name */
  @AuraEnabled
  public static Id getRecordTypeId(String DeveloperName, String ObjectName) {
    return Schema.getGlobalDescribe()
      .get(ObjectName)
      .getDescribe()
      .getRecordTypeInfosByDeveloperName()
      .get(DeveloperName)
      .getRecordTypeId();
  }

  /* With this method you can get a List of "RecordSetWrapper" introducing two strings the fieldSetName and the ObjectName*/
  @AuraEnabled
  public static List<RecordSetWrapper> readFieldSet(
    String fieldSetName,
    String ObjectName
  ) {
    /* Here a map is created to keep references between the fieldSet and the Object*/
    Map<String, Schema.SObjectType> GlobalDescribeMap = Schema.getGlobalDescribe();
    Schema.SObjectType SObjectTypeObj = GlobalDescribeMap.get(ObjectName);
    Schema.DescribeSObjectResult DescribeSObjectResultObj = SObjectTypeObj.getDescribe();
    Schema.FieldSet fieldSetObj = DescribeSObjectResultObj.FieldSets.getMap()
      .get(fieldSetName);
    List<Schema.FieldSetMember> fieldSetMemberList = fieldSetObj.getFields();
    List<RecordSetWrapper> recordSetList = new List<RecordSetWrapper>();
    for (Schema.FieldSetMember fieldSetMemberObj : fieldSetMemberList) {
      RecordSetWrapper wrapper = new RecordSetWrapper();
      wrapper.name = fieldSetMemberObj.getFieldPath();
      wrapper.label = fieldSetMemberObj.getLabel();
      wrapper.type = String.valueOf(fieldSetMemberObj.getType());
      wrapper.required = fieldSetMemberObj.getRequired();
      recordSetList.add(wrapper);
    }
    return recordSetList;
  }

  
  @TestVisible
  private static Map<String, Integer> checkSupplyPointsInB2B(
    Set<String> uspcSet
  ) {
    final Map<String, Integer> resultMap = new Map<String, Integer>();
    final adaptadorSVEWS contextWS = new adaptadorSVEWS();
    Integer result;
    final String resultCallSVE;
    for (String uspc : uspcSet) {
      //everis (ART) Se mueve la comprobación a la carga del componente porque ahora la hace cuando seleccionas
      /*result = 0;
            resultCallSVE = contextWS.requestBySupplyPointTBCCEX028(uspc.deleteWhitespace(), '');
            if (resultCallSVE.contains('ERROR')) {
                result = -1;
            } else 
                if (!String.isEmpty(resultCallSVE)) {
                    result = 1;
                }*/
      result = -1;
      resultMap.put(uspc, result);
    }
    return resultMap;
  }

  /**
   * Get addresses by anything
   * @param searchText Anything
   * @return The addresses
   */
  @AuraEnabled
  public static List<B2C_Address__c> getAddressesByAnything(String searchText) {
    List<B2C_Address__c> addresses = new List<B2C_Address__c>();
    addresses.addAll(getAddressesByAssetName(searchText));
    addresses.addAll(getAddressesByName(searchText));
    addresses.addAll(getAddressesByUSPC(searchText));
    return addresses;
  }

  /**
   * Get addresses by
   * @param searchText The asset name
   * @return The addresses
   */
  @AuraEnabled
  public static List<B2C_Address__c> getAddressesByAssetName(
    String searchText
  ) {
    String searchTxt = (String.escapeSingleQuotes(searchText)).trim();
    List<Asset> assets = new List<Asset>();
    List<B2C_Address__c> addresses = new List<B2C_Address__c>();
    if (Test.isRunningTest()) {
      String queryString =
        'SELECT ' +
        //'Account.Addr_id__r.Name,' +
        //'FI_ASS_LKP_Address__r.Name,' +
        'FI_ASS_LKP_Service_Point__r.AddrId_Id__r.Name ' +
        'FROM ' +
        'Asset ' +
        'WHERE ' +
        'ParentId = NULL AND ' +
        'NE__Status__c = \'Active\' AND ' +
        '(Name LIKE \'%' +
        searchTxt +
        '%\' OR ' +
        'FI_ASS_TXT_CRM_Agree_Number__c LIKE \'%' +
        searchTxt +
        '%\') ' +
        'LIMIT 100';
      assets = Database.query(queryString.trim());
    } else {
      List<List<sObject>> searchList = [
        FIND :searchTxt
        IN ALL FIELDS
        RETURNING
          Asset(
            FI_ASS_LKP_Service_Point__r.AddrId_Id__r.Name
            WHERE ParentId = null AND NE__Status__c = 'Active')
        LIMIT 100
      ];
      if (searchList == null || searchList.size() == 0) {
        return addresses;
      }
      assets = (List<Asset>) searchList[0];
    }
    /*String queryString = 
                'SELECT ' +
                    //'Account.Addr_id__r.Name,' +
                    //'FI_ASS_LKP_Address__r.Name,' +
                    'FI_ASS_LKP_Service_Point__r.AddrId_Id__r.Name ' +
                'FROM ' +
                    'Asset ' +
                'WHERE ' +
                    'ParentId = NULL AND ' +
                    'NE__Status__c = \'Active\' AND ' +
                    '(Name LIKE \'%' + searchTxt + '%\' OR ' +
                    'FI_ASS_TXT_CRM_Agree_Number__c LIKE \'%' + searchTxt + '%\') ' +
                'LIMIT 100';
            List<Asset> assets = Database.query(queryString);*/

    for (Asset asset : assets) {
      Id addressId = null;
      String addressName = null;
      /*if (asset.FI_ASS_LKP_Address__c != null) {
                addressId = asset.FI_ASS_LKP_Address__c;
                addressName = asset.FI_ASS_LKP_Address__r.Name;
            } else*/
      if (
        asset.FI_ASS_LKP_Service_Point__c != null &&
        asset.FI_ASS_LKP_Service_Point__r.AddrId_Id__c != null
      ) {
        addressId = asset.FI_ASS_LKP_Service_Point__r.AddrId_Id__c;
        addressName = asset.FI_ASS_LKP_Service_Point__r.AddrId_Id__r.Name;
      } /*else
                    if (asset.AccountId != null &&
                       asset.Account.Addr_id__c != null)
                	{
                        addressId = asset.Account.Addr_id__c;
                        addressName = asset.Account.Addr_id__r.Name;
                    }*/
      if (addressId != null && addressName != null) {
        B2C_Address__c address = new B2C_Address__c(
          Id = addressId,
          Name = addressName
        );
        addresses.add(address);
      }
    }
    return addresses;
  }

  /**
   * Get addresses by name
   * @param searchText The address name
   * @return The addresses
   */
  @AuraEnabled
  public static List<B2C_Address__c> getAddressesByName(String searchText) {
    String searchTxt = searchText;
    searchTxt = (String.escapeSingleQuotes(searchTxt)).trim();
    List<B2C_Address__c> addressList = new List<B2C_Address__c>();
    addressList.addAll(getNormalizedAddresses(searchTxt));

    Set<String> addressNameSet = new Set<String>();
    for (B2C_Address__c address : addressList) {
      addressNameSet.add(address.Name);
    }

    addressList.addAll(getNotNormalizedAddresses(searchTxt, addressNameSet));
    return addressList;
  }

  @AuraEnabled
  public static List<B2C_Address__c> getAddressesByAccountId(Id accountId) {
    String queryString =
      'SELECT ' +
      'MIN(Id) Id,' +
      'Name ' +
      'FROM ' +
      'B2C_Address__c ' +
      'WHERE ' +
      'Account__c = \'' +
      accountId +
      '\'' +
      'GROUP BY ' +
      'Name ' +
      'LIMIT 100';
    List<AggregateResult> aggregateResultList = Database.query(queryString.trim());
    List<B2C_Address__c> addressList = new List<B2C_Address__c>();
    for (AggregateResult aggregateResult : aggregateResultList) {
      B2C_Address__c address = new B2C_Address__c(
        Id = (Id) aggregateResult.get('Id'),
        Name = (String) aggregateResult.get('Name')
      );
      addressList.add(address);
    }
    System.debug(addressList);
    return addressList;
  }

  private static List<B2C_Address__c> getNormalizedAddresses(
    String searchText
  ) {
    /*String queryString = 
            'SELECT ' +
                'MIN(Id) Id,' +
                'Name ' +
            'FROM ' +
            	'B2C_Address__c ' +
            'WHERE ' +
            	'Name LIKE \'%' + searchText + '%\' ' +
            	'OR Formatedd_Address__c LIKE \'%' + searchText + '%\' ' +
            'GROUP BY ' +
            	'Name ' +
            'LIMIT 100';
        List<AggregateResult> aggregateResultList = Database.query(queryString); */
    List<B2C_Address__c> addressList = new List<B2C_Address__c>();
    List<List<sObject>> searchList = [
      FIND :searchText
      IN ALL FIELDS
      RETURNING B2C_Address__c(Id, Name)
      LIMIT 100
    ];
    if (searchList == null || searchList.size() == 0) {
      return addressList;
    }
    addressList = (List<B2C_Address__c>) searchList[0];
    return addressList;
    /*
        for (AggregateResult aggregateResult : aggregateResultList) {
            B2C_Address__c address = new B2C_Address__c(
            	Id = (Id)aggregateResult.get('Id'),
                Name = (String)aggregateResult.get('Name')
            );
            addressList.add(address);
        }
        return addressList;*/
  }

  private static List<B2C_Address__c> getNotNormalizedAddresses(
    String searchText,
    Set<String> addressNameSet
  ) {
    List<B2C_Address__c> addressList = new List<B2C_Address__c>();
    List<List<sObject>> searchList = [
      FIND :searchText
      IN ALL FIELDS
      RETURNING
        B2C_Service_Point__c(
          Adress__c,
          AddrId_Id__r.Name
          WHERE AddrId_Id__c = null)
      LIMIT 100
    ];
    if (searchList == null || searchList.size() == 0) {
      return addressList;
    }
    List<B2C_Service_Point__c> supplyPointList = (List<B2C_Service_Point__c>) searchList[0];
    for (B2C_Service_Point__c supplyPoint : supplyPointList) {
      String addressName = (String) supplyPoint.get('Adress__c');
      if (!addressNameSet.contains(addressName)) {
        B2C_Address__c address = new B2C_Address__c(Name = addressName);
        addressList.add(address);
      }
    }
    return addressList;
  }

  /**
   * Get addresses by Universal Supply Point Code
   * @param searchText The Universal Supply Point Code
   * @return The addresses
   */
  @AuraEnabled
  public static List<B2C_Address__c> getAddressesByUSPC(String searchText) {
    String searchTxt = searchText;

    searchTxt = (String.escapeSingleQuotes(searchTxt)).trim();
    /*String queryString = 
            'SELECT ' +
                'AddrId_Id__r.Name,' +
            	'Adress__c ' +
            'FROM ' +
            	'B2C_Service_Point__c ' +
            'WHERE ' +
            	'Name LIKE \'%' + searchTxt + '%\' ' +
            'LIMIT 100';
	List<B2C_Service_Point__c> supplyPoints = Database.query(queryString);*/
    List<B2C_Address__c> addresses = new List<B2C_Address__c>();
    List<List<sObject>> searchList = [
      FIND :searchTxt
      IN ALL FIELDS
      RETURNING B2C_Service_Point__c(Adress__c, AddrId_Id__r.Name)
      LIMIT 100
    ];
    //System.debug('ARTQuery' + [Select id, name from B2C_Service_Point__c where name = :searchTxt]);
    //System.debug('ARTsearchTextZZZ' + searchTxt + 'ZZZ');
    //System.debug('ARTsearchList' + searchList);
    if (searchList == null || searchList.size() == 0) {
      return addresses;
    }
    List<B2C_Service_Point__c> supplyPoints = (List<B2C_Service_Point__c>) searchList[0];
      for (B2C_Service_Point__c supplyPoint : supplyPoints) {
          if(supplyPoint.AddrId_Id__c != null) {
              B2C_Address__c address = new B2C_Address__c(
                  Id = supplyPoint.AddrId_Id__c,
                  Name = supplyPoint.AddrId_Id__r.Name
              );
              addresses.add(address);
          }
      }
    return addresses;
  }

  /**
   * Get address filter string
   * @param searchText The search text
   * @return The address filter string
   */
  private static String getAssetsAddressFilter(String searchText) {
    return '(FI_ASS_LKP_Service_Point__r.AddrName__c = \'' +
      searchText +
      '\' OR ' +
      'FI_ASS_LKP_Service_Point__r.AddrId_Id__r.Formatedd_Address__c = \'' +
      searchText +
      '\' OR ' +
      'FI_ASS_LKP_Service_Point__r.AddrId_Id__r.Name = \'' +
      searchText +
      '\' OR ' +
      'FI_ASS_LKP_Service_Point__r.Adress__c = \'' +
      searchText +
      //'\' OR ' + 'FI_ASS_LKP_Address__r.Formatedd_Address__c = \'' + searchText +
      //'\' OR ' + 'FI_ASS_LKP_Address__r.Name = \'' + searchText +
      //'\' OR ' + 'Account.Addr_id__r.Formatedd_Address__c = \'' + searchText +
      //'\' OR ' + 'Account.Addr_id__r.Name = \'' + searchText +
      '\')';
  }

  /**
   * Get USPC filter string
   * @param searchText The search text
   * @return The address filter string
   */
  /*private static String getSupplyPointsFilter(String searchText) {
        return '(AddrId_Id__r.Name = \'' + searchText +
        	'\' OR Adress__c LIKE \'%' + searchText + '%\')';
    }*/

  private static String getSupplyPointsFilterByAccountId(Id accountId) {
    return 'Account_id__c = \'' + accountId + '\'';
  }

  // Asset del cliente que no sean de No energéticos para que en botón nueva oferta no aparezacan ya que no se pueden realizar CCIntra
  private static String getAssetsAddressFilterByAccountId(Id accountId) {
    return 'AccountId = \'' +
      accountId +
      '\' AND FI_ASS_SEL_BusinessLine__c != \'03\' AND FI_ASS_SEL_BusinessLine__c != \'04\'';
  }
  //ByFJDM
  // Asset del cliente que no sean de No energéticos para que en botón nueva oferta no aparezacan ya que no se pueden realizar CCIntra
  private static String getAssetsNotEnerAddressFilterByAccountId(Id accountId) {
    return 'AccountId = \'' +
      accountId +
      '\' AND (FI_ASS_SEL_BusinessLine__c = \'03\' OR FI_ASS_SEL_BusinessLine__c = \'04\')';
  }
  //----
  @AuraEnabled
  public static List<TableRowWrapper> getRecordsByAccountId(Id accountId) {
    system.debug('punto 1 ' + System.now());
    String queryString =
      getAssetsFields() + getAssetsAddressFilterByAccountId(accountId);
    List<Asset> assets = getAssets(queryString);
    system.debug('assetsEnergeticos ->' + assets);
    //--------ByFJDM
    queryString =
      getAssetsFields() + getAssetsNotEnerAddressFilterByAccountId(accountId);
    List<Asset> assetsNE = getAssets(queryString);
    system.debug('assetsNoEnergeticos ->' + assetsNE);
    //-------------
    Map<Id, List<Asset>> assetsWithSupplyPoint = new Map<Id, List<Asset>>();
    List<Asset> assetsWithoutSupplyPoint = new List<Asset>();
    for (Asset asset : assets) {
      if (asset.FI_ASS_LKP_Service_Point__c == null) {
        assetsWithoutSupplyPoint.add(asset);
      } else {
        if (
          !assetsWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)
        ) {
          assetsWithSupplyPoint.put(
            asset.FI_ASS_LKP_Service_Point__c,
            new List<Asset>()
          );
        }
        List<Asset> assetList = assetsWithSupplyPoint.get(
          asset.FI_ASS_LKP_Service_Point__c
        );
        assetList.add(asset);
        assetsWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetList);
      }
    }
    //--------ByFJDM
    Map<Id, List<Asset>> assetsNEWithSupplyPoint = new Map<Id, List<Asset>>();
    for (Asset asset : assetsNE) {
      if (asset.FI_ASS_LKP_Service_Point__c != null) {
        if (
          !assetsNEWithSupplyPoint.containsKey(
            asset.FI_ASS_LKP_Service_Point__c
          )
        ) {
          assetsNEWithSupplyPoint.put(
            asset.FI_ASS_LKP_Service_Point__c,
            new List<Asset>()
          );
        }
        List<Asset> assetNEList = assetsNEWithSupplyPoint.get(
          asset.FI_ASS_LKP_Service_Point__c
        );
        assetNEList.add(asset);
        assetsNEWithSupplyPoint.put(
          asset.FI_ASS_LKP_Service_Point__c,
          assetNEList
        );
      }
    }
    //-------------
    system.debug('assetsWithSupplyPoint Energeticos ' + assetsWithSupplyPoint);
    system.debug(
      'assetsWithoutSupplyPoint Energeticos' + assetsWithoutSupplyPoint
    );

    system.debug('punto 2 ' + System.now());
    queryString =
      getSupplyPointsFields() + getSupplyPointsFilterByAccountId(accountId);
    system.debug('punto x ' + System.now());
    List<B2C_Service_Point__c> supplyPoints = getSupplyPoints(queryString);
    Map<Id, Boolean> inProgressSupplyPointMap = getSupplyPointsAvailability(
      supplyPoints
    );
    system.debug('supplyPoints ' + supplyPoints);
    system.debug(
      'inProgressSupplyPointMap en vuelo' + inProgressSupplyPointMap
    );

    Map<String, B2C_Service_Point__c> supplyPointsWithoutB2CAsset = new Map<String, B2C_Service_Point__c>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      system.debug('punto loop for' + System.now());
      if (!assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        supplyPointsWithoutB2CAsset.put(supplyPoint.Name, supplyPoint);
        system.debug('punto dentro if' + System.now());
      }
    }

    system.debug('supplyPointsWithoutB2CAsset' + supplyPointsWithoutB2CAsset);
    Map<String, Integer> uspcMap;
    if (!supplyPointsWithoutB2CAsset.isEmpty()) {
      system.debug('punto dentro if 2' + System.now());
      Set<String> uspcSet = supplyPointsWithoutB2CAsset.keySet();
      system.debug('punto Set<String> uspcSet ' + System.now());
      uspcMap = checkSupplyPointsInB2B(uspcSet);
      system.debug('punto uspcMap ' + System.now());
    }
    system.debug('punto3 ' + System.now());

    List<Asset> assetWithSupplyPointList = new List<Asset>();
    List<Asset> assetWithNESupplyPointList = new List<Asset>();
    List<TableRowWrapper> tableRowWrapperList = new List<TableRowWrapper>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      //---------ByFJDM
      system.debug('punto3.3 ' + System.now());
      if (assetsNEWithSupplyPoint.containsKey(supplyPoint.Id)) {
        system.debug('punto3.4 ' + System.now());
        assetWithNESupplyPointList = assetsNEWithSupplyPoint.get(
          supplyPoint.Id
        );

        for (Asset assetWithSupplyPointItem : assetWithNESupplyPointList) {
          TableRowWrapper tableRowWrapper = new TableRowWrapper();
          tableRowWrapper.SupplyPoint = supplyPoint;
          //tableRowWrapper.SupplyPointInProgress = false;
          //--- Atos 2019/11/29
          if (inProgressSupplyPointMap.containsKey(supplyPoint.Id)) {
            tableRowWrapper.SupplyPointInProgress = inProgressSupplyPointMap.get(
              supplyPoint.Id
            );
          }
          //---
          tableRowWrapper.Id = assetWithSupplyPointItem.Id;
          tableRowWrapper.Asset = assetWithSupplyPointItem;

          tableRowWrapperList.add(tableRowWrapper);
        }
      }
      system.debug('punto3.5 ' + System.now());
      //------------
      if (assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        system.debug('punto3.1 ' + System.now());
        assetWithSupplyPointList = assetsWithSupplyPoint.get(supplyPoint.Id);

        for (Asset assetWithSupplyPointItem : assetWithSupplyPointList) {
          system.debug('punto3.2 ' + System.now());
          TableRowWrapper tableRowWrapper = new TableRowWrapper();
          tableRowWrapper.SupplyPoint = supplyPoint;
          //tableRowWrapper.SupplyPointInProgress = false;
          //--- Atos 2019/11/29
          if (inProgressSupplyPointMap.containsKey(supplyPoint.Id)) {
            tableRowWrapper.SupplyPointInProgress = inProgressSupplyPointMap.get(
              supplyPoint.Id
            );
          }
          //---
          tableRowWrapper.Id = assetWithSupplyPointItem.Id;
          tableRowWrapper.Asset = assetWithSupplyPointItem;

          tableRowWrapperList.add(tableRowWrapper);
        }
      } else {
        TableRowWrapper tableRowWrapper = new TableRowWrapper();

        tableRowWrapper.SupplyPoint = supplyPoint;
        tableRowWrapper.SupplyPointInProgress = false;
        if (inProgressSupplyPointMap.containsKey(supplyPoint.Id)) {
          tableRowWrapper.SupplyPointInProgress = inProgressSupplyPointMap.get(
            supplyPoint.Id
          );
        }
        tableRowWrapper.Id = supplyPoint.Id;
        tableRowWrapper.AssetInB2B = (uspcMap.containsKey(supplyPoint.Name) &&
          uspcMap.get(supplyPoint.Name) == 1)
          ? true
          : false;

        tableRowWrapperList.add(tableRowWrapper);
      }
    }
    system.debug('punto 4 ' + System.now());

    for (Asset assetWithoutSupplyPoint : assetsWithoutSupplyPoint) {
      TableRowWrapper tableRowWrapper = new TableRowWrapper();
      tableRowWrapper.Id = assetWithoutSupplyPoint.Id;
      tableRowWrapper.Asset = assetWithoutSupplyPoint;
      tableRowWrapperList.add(tableRowWrapper);
    }
    system.debug('punto 5 ' + System.now());
    system.debug('tableRowWrapperList -> ' + tableRowWrapperList);

    return tableRowWrapperList;
  }

  //--- ATOS 2020/01/07 Fix defect E2EPQA-908
  @AuraEnabled
  public static Boolean getConfigurationItemInProgress(
    String psId,
    String businessLineName
  ) {
    Boolean flylineFlag = true;
    NE__OrderItem__c[] flyLine = null;

    if (Schema.sObjectType.NE__OrderItem__c.isAccessible()) {
      flyLine = [
        SELECT
          Id,
          Name,
          FI_CI_LKP_CUPS__c,
          toLabel(FI_CI_SEL_Business_Line__c),
          FI_CI_LKP_Asset__c,
          FI_CI_LKP_Asset__r.FI_ASS_SEL_BusinessLine__c
        FROM NE__OrderItem__c
        WHERE
          FI_CI_LKP_CUPS__c = :psId
          AND NE__Status__c IN (
            :Label.FI_CI_STATUS_PENDING,
            :Label.FI_CI_STATUS_SIGN_PENDING,
            :Label.FI_CI_STATUS_SIGNED,
            :Label.FI_CI_STATUS_TASK_PENDING,
            :Label.FI_CI_STATUS_REC_PENDING,
            :Label.FI_CI_STATUS_CRMTRANSFER_PENDING,
            :Label.FI_CI_STATUS_CRMTRANSFER_OK,
            :Label.FI_CI_STATUS_CRMTRANSFER_ERROR,
            :Label.FI_CI_STATUS_CRM_APPROVED,
            :Label.FI_CI_STATUS_CRM_SENT,
            :Label.FI_CI_STATUS_CRM_SHIPPING,
            :Label.FI_CI_STATUS_CRM_PENDJOINTACT,
            :Label.FI_CI_STATUS_CRM_PENDCANCEL,
            :Label.FI_CI_STATUS_CRM_PENDCONTROL,
            :Label.FI_CI_STATUS_CRM_REJECTPENDMANAGE
          )
          AND NE__Parent_Order_Item__c = null
          AND toLabel(FI_CI_SEL_Business_Line__c) = :businessLineName
        ORDER BY FI_CI_LKP_CUPS__c, FI_CI_SEL_Business_Line__c ASC
      ];
    }

    if (flyLine == null || flyLine.isEmpty()) {
      flylineFlag = false;
    }
    return flylineFlag;
  }
  //--- Atos 2020/01/07 FIN

  /**
   * Get assets by address name
   * @param addressName The address name
   * @return The address' assets
   */
  @AuraEnabled
  public static List<TableRowWrapper> getRecordsByAddressName(String searchText) {
    String searchTxt = (String.escapeSingleQuotes(searchText)).trim();
    Set<String> AddressId = new Set<String>();
    String searchAddress = 'FIND :searchTxt IN ALL FIELDS RETURNING B2C_Address__c(Id, Formatedd_Address__c, Name)';
    List<List<SObject>> searchList = search.query(searchAddress);
    List<B2C_Address__c> address = (List<B2C_Address__c>) searchList[0];
    for (B2C_Address__c ad : address) {
      AddressId.add(ad.Id);
    }
    system.debug('@@@ AddressId' + AddressId);

     //---byFJDM
       String assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__r.AddrId_Id__c IN :AddressId)AND FI_ASS_SEL_BusinessLine__c != \'03\' AND FI_ASS_SEL_BusinessLine__c != \'04\'';
        List<Asset> assets = database.query(assetQuery);
        assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__r.AddrId_Id__c IN :AddressId)AND (FI_ASS_SEL_BusinessLine__c = \'03\' OR FI_ASS_SEL_BusinessLine__c = \'04\')';
        List<Asset> assetsNE = database.query(assetQuery);
    //------

    Map<Id, List<Asset>> assetsWithSupplyPoint = new Map<Id, List<Asset>>();
    List<Asset> assetsWithoutSupplyPoint = new List<Asset>();
    for (Asset asset : assets) {
      if (asset.FI_ASS_LKP_Service_Point__c == null) {
        assetsWithoutSupplyPoint.add(asset);
      } else {
        if (
          !assetsWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)
        ) {
          assetsWithSupplyPoint.put(
            asset.FI_ASS_LKP_Service_Point__c,
            new List<Asset>()
          );
        }
        List<Asset> assetList = assetsWithSupplyPoint.get(
          asset.FI_ASS_LKP_Service_Point__c
        );
        assetList.add(asset);
        assetsWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetList);
      }
    }

     //--------ByFJDM
         Map<Id,List<Asset>> assetsNEWithSupplyPoint = new Map<Id,List<Asset>>();
        for (Asset asset : assetsNE) {
            if (asset.FI_ASS_LKP_Service_Point__c != null) {
                if (!assetsNEWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)) {
                    assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, new List<Asset>());
                }
                List<Asset> assetNEList = assetsNEWithSupplyPoint.get(asset.FI_ASS_LKP_Service_Point__c);
                assetNEList.add(asset);
                assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetNEList);
            }
        }
        //-------------
    String queryString = getSupplyPointsFields() + ' AddrId_Id__c IN :AddressId';
   List<B2C_Service_Point__c> supplyPoints = Database.query(queryString.trim());
      if (supplyPoints.size() == 0) {
          //Para las direcciones no normalizadas
          supplyPoints = getSupplyPointSosl(searchTxt);
      }
    Map<Id, Boolean> inProgressSupplyPointMap = getSupplyPointsAvailability(
      supplyPoints
    );

    Map<String, B2C_Service_Point__c> supplyPointsWithoutB2CAsset = new Map<String, B2C_Service_Point__c>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      if (!assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        supplyPointsWithoutB2CAsset.put(supplyPoint.Name, supplyPoint);
      }
    }

    Map<String, Integer> uspcMap;
    if (!supplyPointsWithoutB2CAsset.isEmpty()) {
      Set<String> uspcSet = supplyPointsWithoutB2CAsset.keySet();
      uspcMap = checkSupplyPointsInB2B(uspcSet);
    }
    return getTableRowWrapper(
      supplyPoints,
      uspcMap,
      assetsWithSupplyPoint,
      assetsWithoutSupplyPoint,
      inProgressSupplyPointMap,
      assetsNEWithSupplyPoint
    );
  }
    
    @AuraEnabled
  public static List<TableRowWrapper> getRecordsByAddressId(String AddressId) {
    system.debug('@@@ AddressId' + AddressId);

     //---byFJDM
       String assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__r.AddrId_Id__c = :AddressId)AND FI_ASS_SEL_BusinessLine__c != \'03\' AND FI_ASS_SEL_BusinessLine__c != \'04\'';
        List<Asset> assets = database.query(assetQuery);
        assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__r.AddrId_Id__c = :AddressId)AND (FI_ASS_SEL_BusinessLine__c = \'03\' OR FI_ASS_SEL_BusinessLine__c = \'04\')';
        List<Asset> assetsNE = database.query(assetQuery);
    //------

    Map<Id, List<Asset>> assetsWithSupplyPoint = new Map<Id, List<Asset>>();
    List<Asset> assetsWithoutSupplyPoint = new List<Asset>();
    for (Asset asset : assets) {
      if (asset.FI_ASS_LKP_Service_Point__c == null) {
        assetsWithoutSupplyPoint.add(asset);
      } else {
        if (
          !assetsWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)
        ) {
          assetsWithSupplyPoint.put(
            asset.FI_ASS_LKP_Service_Point__c,
            new List<Asset>()
          );
        }
        List<Asset> assetList = assetsWithSupplyPoint.get(
          asset.FI_ASS_LKP_Service_Point__c
        );
        assetList.add(asset);
        assetsWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetList);
      }
    }

     //--------ByFJDM
         Map<Id,List<Asset>> assetsNEWithSupplyPoint = new Map<Id,List<Asset>>();
        for (Asset asset : assetsNE) {
            if (asset.FI_ASS_LKP_Service_Point__c != null) {
                if (!assetsNEWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)) {
                    assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, new List<Asset>());
                }
                List<Asset> assetNEList = assetsNEWithSupplyPoint.get(asset.FI_ASS_LKP_Service_Point__c);
                assetNEList.add(asset);
                assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetNEList);
            }
        }
        //-------------
    String queryString = getSupplyPointsFields() + ' AddrId_Id__c = :AddressId';
   List<B2C_Service_Point__c> supplyPoints = Database.query(queryString.trim());
    Map<Id, Boolean> inProgressSupplyPointMap = getSupplyPointsAvailability(
      supplyPoints
    );

    Map<String, B2C_Service_Point__c> supplyPointsWithoutB2CAsset = new Map<String, B2C_Service_Point__c>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      if (!assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        supplyPointsWithoutB2CAsset.put(supplyPoint.Name, supplyPoint);
      }
    }

    Map<String, Integer> uspcMap;
    if (!supplyPointsWithoutB2CAsset.isEmpty()) {
      Set<String> uspcSet = supplyPointsWithoutB2CAsset.keySet();
      uspcMap = checkSupplyPointsInB2B(uspcSet);
    }
    return getTableRowWrapper(
      supplyPoints,
      uspcMap,
      assetsWithSupplyPoint,
      assetsWithoutSupplyPoint,
      inProgressSupplyPointMap,
      assetsNEWithSupplyPoint
    );
  }
    
    
    
    
    
    /*
@AuraEnabled
  private static List<TableRowWrapper> getRecordsByAddressName(
    String searchText
  ) {
    system.debug('@@@getRecordsByAddressName searchText: ' + searchText);
    searchText = (String.escapeSingleQuotes(searchText)).trim();
    Set<String> AddressId = new Set<String>();
    //String queryString = getAssetsFields() + getAssetsAddressFilter(searchText);
    // List<Asset> assets = getAssets(queryString);
    String searchAddress = 'FIND :searchText IN ALL FIELDS RETURNING B2C_Address__c(Id, Formatedd_Address__c, Name)';
    List<List<SObject>> searchList = search.query(searchAddress);
    List<B2C_Address__c> address = (List<B2C_Address__c>) searchList[0];
    for (B2C_Address__c ad : address) {
      AddressId.add(ad.Id);
    }
      System.debug('ARV AddressId' + AddressId);
    Set<String> spId = new Set<String>();
    String searchSP = 'FIND :searchText IN ALL FIELDS RETURNING B2C_Service_Point__c(Id, AddrName__c, Adress__c)';
    List<List<SObject>> searchList2 = search.query(searchSP);
    List<B2C_Service_Point__c> sps = (List<B2C_Service_Point__c>) searchList2[0];
    for (B2C_Service_Point__c sp : sps) {
      spId.add(sp.Id);
    }
    System.debug('ARV B2C_Service_Point__c' + spId);
    system.debug('@@@ spId' + spId);
    system.debug('@@@ AddressId' + AddressId);
   // String assetQuery = getAssetsFields() +' (FI_ASS_LKP_Service_Point__c IN :spId OR FI_ASS_LKP_Service_Point__r.AddrId_Id__c IN :AddressId)';
   // system.debug('@@@ assetQuery: ' + assetQuery);
   // List<Asset> assets = database.query(assetQuery);
   // system.debug('@@@ assets: ' + assets);

     //---byFJDM
       String assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__c IN :spId OR FI_ASS_LKP_Service_Point__r.AddrId_Id__c IN :AddressId)AND FI_ASS_SEL_BusinessLine__c != \'03\' AND FI_ASS_SEL_BusinessLine__c != \'04\'';
        system.debug('@@@ assetQuery: ' +assetQuery);
        List<Asset> assets = database.query(assetQuery);
        system.debug('@@@ assets: ' +assets);

        assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__c IN :spId OR FI_ASS_LKP_Service_Point__r.AddrId_Id__c IN :AddressId)AND (FI_ASS_SEL_BusinessLine__c = \'03\' OR FI_ASS_SEL_BusinessLine__c = \'04\')';
        system.debug('@@@ assetQuery: ' +assetQuery);
        List<Asset> assetsNE = database.query(assetQuery);
        system.debug('@@@ assets: ' +assetsNE);

    //------

    Map<Id, List<Asset>> assetsWithSupplyPoint = new Map<Id, List<Asset>>();
    List<Asset> assetsWithoutSupplyPoint = new List<Asset>();
    for (Asset asset : assets) {
      if (asset.FI_ASS_LKP_Service_Point__c == null) {
        assetsWithoutSupplyPoint.add(asset);
      } else {
        if (
          !assetsWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)
        ) {
          assetsWithSupplyPoint.put(
            asset.FI_ASS_LKP_Service_Point__c,
            new List<Asset>()
          );
        }
        List<Asset> assetList = assetsWithSupplyPoint.get(
          asset.FI_ASS_LKP_Service_Point__c
        );
        assetList.add(asset);
        assetsWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetList);
      }
    }

     //--------ByFJDM
         Map<Id,List<Asset>> assetsNEWithSupplyPoint = new Map<Id,List<Asset>>();
        for (Asset asset : assetsNE) {
            if (asset.FI_ASS_LKP_Service_Point__c != null) {
                if (!assetsNEWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)) {
                    assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, new List<Asset>());
                }
                List<Asset> assetNEList = assetsNEWithSupplyPoint.get(asset.FI_ASS_LKP_Service_Point__c);
                assetNEList.add(asset);
                assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetNEList);
            }
        }
        //-------------
    //ARV
    //queryString = getSupplyPointsFields() + getSupplyPointsFilter(searchText);
        
     //   List<B2C_Service_Point__c> supplyPoints = getSupplyPoints(queryString);
    List<B2C_Service_Point__c> supplyPoints = getSupplyPointSosl(searchText);
    //ARV
System.debug('ARV supplyPoints' + supplyPoints);
    Map<Id, Boolean> inProgressSupplyPointMap = getSupplyPointsAvailability(
      supplyPoints
    );

    Map<String, B2C_Service_Point__c> supplyPointsWithoutB2CAsset = new Map<String, B2C_Service_Point__c>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      if (!assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        supplyPointsWithoutB2CAsset.put(supplyPoint.Name, supplyPoint);
      }
    }

    Map<String, Integer> uspcMap;
    if (!supplyPointsWithoutB2CAsset.isEmpty()) {
      Set<String> uspcSet = supplyPointsWithoutB2CAsset.keySet();
      uspcMap = checkSupplyPointsInB2B(uspcSet);
    }
    return getTableRowWrapper(
      supplyPoints,
      uspcMap,
      assetsWithSupplyPoint,
      assetsWithoutSupplyPoint,
      inProgressSupplyPointMap,
      assetsNEWithSupplyPoint
    );
    //return new List<TableRowWrapper>();
  }
*/
  @TestVisible
  private static List<TableRowWrapper> getTableRowWrapper(
    List<B2C_Service_Point__c> supplyPoints,
    Map<String, Integer> uspcMap,
    Map<Id, List<Asset>> assetsWithSupplyPoint,
    List<Asset> assetsWithoutSupplyPoint,
    Map<Id, Boolean> inProgressSupplyPointMap,
    Map<Id, List<Asset>> assetsNEWithSupplyPoint
  ) {
    List<Asset> assetWithSupplyPointList = new List<Asset>();
    List<Asset> assetWithNESupplyPointList = new List<Asset>();
    List<TableRowWrapper> tableRowWrapperList = new List<TableRowWrapper>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
       //---------ByFJDM
                 system.debug('punto3.3 ' + System.now());
                    if (assetsNEWithSupplyPoint.containsKey(supplyPoint.Id)) {
                     system.debug('punto3.4 ' + System.now());
                     assetWithNESupplyPointList = assetsNEWithSupplyPoint.get(supplyPoint.Id);
                    
                    for (Asset assetWithSupplyPointItem : assetWithNESupplyPointList) {
                        
                        TableRowWrapper tableRowWrapper = new TableRowWrapper();
                        tableRowWrapper.SupplyPoint = supplyPoint;
                        //tableRowWrapper.SupplyPointInProgress = false;
                        //--- Atos 2019/11/29
                        if (inProgressSupplyPointMap.containsKey(supplyPoint.Id)) {
                            tableRowWrapper.SupplyPointInProgress = inProgressSupplyPointMap.get(supplyPoint.Id);                    
                        }
                        //---
                        tableRowWrapper.Id = assetWithSupplyPointItem.Id;
                        tableRowWrapper.Asset = assetWithSupplyPointItem;
                        
                        tableRowWrapperList.add(tableRowWrapper);
                        
                    }
                }
                 system.debug('punto3.5 ' + System.now());
                //------------
      
      if (assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        assetWithSupplyPointList = assetsWithSupplyPoint.get(supplyPoint.Id);

        for (Asset assetWithSupplyPointItem : assetWithSupplyPointList) {
          TableRowWrapper tableRowWrapper = new TableRowWrapper();
          tableRowWrapper.SupplyPoint = supplyPoint;
          //tableRowWrapper.SupplyPointInProgress = false;
          //--- Atos 2019/11/29
          if (inProgressSupplyPointMap.containsKey(supplyPoint.Id)) {
            tableRowWrapper.SupplyPointInProgress = inProgressSupplyPointMap.get(
              supplyPoint.Id
            );
          }
          //---
          tableRowWrapper.Id = assetWithSupplyPointItem.Id;
          tableRowWrapper.Asset = assetWithSupplyPointItem;

          tableRowWrapperList.add(tableRowWrapper);
        }
      } else {
        TableRowWrapper tableRowWrapper = new TableRowWrapper();
        tableRowWrapper.SupplyPointInProgress = false;
        if (inProgressSupplyPointMap.containsKey(supplyPoint.Id)) {
          tableRowWrapper.SupplyPointInProgress = inProgressSupplyPointMap.get(
            supplyPoint.Id
          );
        }
        tableRowWrapper.SupplyPoint = supplyPoint;
        tableRowWrapper.Id = supplyPoint.Id;
        tableRowWrapper.AssetInB2B = (uspcMap.containsKey(supplyPoint.Name) &&
          uspcMap.get(supplyPoint.Name) == 1)
          ? true
          : false;

        tableRowWrapperList.add(tableRowWrapper);
      }
    }

    for (Asset assetWithoutSupplyPoint : assetsWithoutSupplyPoint) {
      TableRowWrapper tableRowWrapper = new TableRowWrapper();
      tableRowWrapper.Id = assetWithoutSupplyPoint.Id;
      tableRowWrapper.Asset = assetWithoutSupplyPoint;
      tableRowWrapperList.add(tableRowWrapper);
    }
    System.debug(tableRowWrapperList);
    return tableRowWrapperList;
  }
  //getAddrName
  @AuraEnabled
  public static string getAddrName(String psId) {
      if (Schema.sObjectType.B2C_Address__c.isAccessible()) {
        return [SELECT Name FROM B2C_Address__c WHERE Id = :psId].Name;
      } else {
        return '';
      }
  }

  /**
   * Get assets with configuration item's status
   * @param queryString The query string
   * @return The assets with configuration item's status
   */
  private static List<Asset> getAssets(String queryString) {
    final String queryStr = queryString + ' ORDER BY CreatedDate DESC';
    final List<Asset> assetsList = Database.query(queryStr.trim());
    //Set<Id> assetsConfigurationIds = getAssetsConfigurationIds(assetsList);
    //List<NE__OrderItem__c> configurationItemList = getAssetsConfigurationItems(assetsConfigurationIds);
    //Map<Id,String> statusMap = getStatusMap(configurationItemList);
    //return replaceAssetsStatus(assetsList, statusMap);
    return assetsList;
  }

  /**
   * Get asset's fields
   * @return The asset's fields
   */
  private static String getAssetsFields() {
    return 'SELECT ' +
      'Account.Name,' +
      'FI_ASS_LKP_Service_Point__c,' +
      //'Estimated_annual_consumption_kWh__c ' +
      'toLabel(FI_ASS_SEL_Rate__c),' +
      'FI_ASS_NUM_Power_T_Hire_1__c,' +
      'FI_ASS_NUM_Power_T_Hire_2__c,' +
      'FI_ASS_NUM_Power_T_Hire_3__c,' +
      'FI_ASS_SEL_BusinessLine__c,' +
      'FI_ASS_SEL_HolderCompany__c,' +
      'toLabel(FI_ASS_SEL_BusinessLine__c) BusinessLineName,' +
      'FI_ASS_SEL_CRM_Agree_Type__c,' +
      'toLabel(FI_ASS_SEL_CRM_Agree_Type__c) AssetTypeName,' +
      'Name,' +
      'NE__ProdId__r.Name,' +
      'toLabel(NE__Status__c) AssetStatusName ' +
      'FROM ' +
      'Asset ' +
      'WHERE ' +
      'ParentId = NULL AND ' +
      '(NE__Status__c = \'In Progress\' OR ' +
      'NE__Status__c = \'Active\') AND ';
    //'(NE__Status__c = \'Active\') AND ';
  }

  /**
   * Get the supply points
   * @param queryString The query string
   * @return The supply points
   */
  private static List<B2C_Service_Point__c> getSupplyPoints(String queryString) {
    final List<B2C_Service_Point__c> supplyPoints = Database.query(queryString.trim());
    //Set<Id> assetsConfigurationIds = getAssetsConfigurationIds(assetsList);
    //List<NE__OrderItem__c> configurationItemList = getAssetsConfigurationItems(assetsConfigurationIds);
    //Map<Id,String> statusMap = getStatusMap(configurationItemList);
    //return replaceAssetsStatus(assetsList, statusMap);
    return supplyPoints;
  }

  /**
   * Get supply points' availability from an account
   * @param accountId The account id
   * @return The account's supply point's availability
   * False means Available.
   * True means Not Available.
   */
  private static Map<Id, Boolean> getSupplyPointsAvailability(List<B2C_Service_Point__c> supplyPoints) 
  {
    final Map<Id, Boolean> inProgressSupplyPointMap = new Map<Id, Boolean>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      inProgressSupplyPointMap.put(supplyPoint.Id, false);
    }
    final Map<String, String> mapFlyLinesByPS = new Map<String, String>();
    mapFlyLinesByPS.putAll(
      FI_ValidationsService_Utils.getMapFlyLinesByPS(
        inProgressSupplyPointMap.keySet()
      )
    );
    mapFlyLinesByPS.putAll(
      FI_ValidationsService_Utils.getMapFlyLinesCRMByPS(
        inProgressSupplyPointMap.keySet()
      )
    );
    for (String key : mapFlyLinesByPS.keySet()) {
      // The key is a concatenation of Supply Point id and Business Line
      // To get just the Supply Point id I had to remove last two characters
      Id supplyPointId = key.substring(0, 18);//key.length() - 2
      if (inProgressSupplyPointMap.containsKey(supplyPointId)) {
        inProgressSupplyPointMap.put(supplyPointId, true);
      }
    }
    return inProgressSupplyPointMap;
  }

    @TestVisible
  private static List<B2C_Service_Point__c> getSupplyPointSosl(String searchText) 
  {
    List<B2C_Service_Point__c> supplyPoints = new List<B2C_Service_Point__c>();
    final List<List<sObject>> searchList = [
      FIND :searchText
      IN ALL FIELDS
      RETURNING
        B2C_Service_Point__c(
          toLabel(Tariff_cd__c),
          Adress__c,
          AddrId_Id__c,
          Account_id__r.Name,
          AddrId_Id__r.Name,
          Name,
          Business_line_cd__c,
          CNAE__c,
          Power_period_1_Kw__c,
          Power_period_2_Kw__c,
          Power_period_3_Kw__c,
          Estimated_annual_consumption_kWh__c)
      LIMIT 100
    ];
    if (searchList == null || searchList.size() == 0) {
      return supplyPoints;
    }
    supplyPoints = (List<B2C_Service_Point__c>) searchList[0];
    return supplyPoints;
  }

  /**
   * Get supply point's fields
   * @return The supply point's fields
   */
  private static String getSupplyPointsFields() {
    return 'SELECT ' +
      'Account_id__r.Name,' +
      'AddrId_Id__r.Name,' +
      'Adress__c,' +
      'Name,' +
      'Business_line_cd__c,' +
      'CNAE__c,' +
      'toLabel(Business_line_cd__c) BusinessLineName,' +
      'Power_period_1_Kw__c,' +
      'Power_period_2_Kw__c,' +
      'Power_period_3_Kw__c,' +
      'toLabel(Tariff_cd__c),' +
      'Estimated_annual_consumption_kWh__c ' +
      'FROM ' +
      'B2C_Service_Point__c ' +
      'WHERE ';
  }
  //getPicklistValues
  @AuraEnabled
  public static Map<String, String> getPicklistValues(String objectApiname,String fieldName) 
  {
      final Map<String, String> mapPickvals = new Map<String, String>();
      Schema.SObjectType targetType = Schema.getGlobalDescribe().get(objectApiname);
      Sobject objectname = targetType.newSObject();
      Schema.sObjectType sobjecttype = objectname.getSObjectType();
      Schema.DescribeSObjectResult sobjectdescribe = sobjecttype.getDescribe();
      Map<String, Schema.SObjectField> fieldmap = sobjectdescribe.fields.getMap();
      List<Schema.PicklistEntry> picklistvalues = fieldmap.get(fieldName).getDescribe().getPickListValues();
      for (Schema.PicklistEntry a : picklistvalues) {
        mapPickvals.put(a.getValue(), a.getLabel());
      }
      return mapPickvals;
  }
    
      /**
   * Get assets by address name
   * @param addressName The address name
   * @return The address' assets
   */
  @AuraEnabled
  public static List<TableRowWrapper> getRecordsByCUPS(String searchText) {
    String searchTxt = searchText;

    searchTxt = (String.escapeSingleQuotes(searchTxt)).trim();
    /*Set<String> AddressId = new Set<String>();
    String searchAddress = 'FIND :searchTxt IN ALL FIELDS RETURNING B2C_Address__c(Id, Formatedd_Address__c, Name)';
    List<List<SObject>> searchList = search.query(searchAddress);
    List<B2C_Address__c> address = (List<B2C_Address__c>) searchList[0];
    for (B2C_Address__c ad : address) {
      AddressId.add(ad.Id);
    }
    system.debug('@@@ AddressId' + AddressId);
*/
      
          String queryString = getSupplyPointsFields() + ' Name = :searchTxt';
   List<B2C_Service_Point__c> supplyPoints = Database.query(queryString.trim());
      Set<String> spIds = new Set<String>();
      for (B2C_Service_Point__c spAux : supplyPoints) {
      spIds.add(spAux.Id);
    }
      
     //---byFJDM
       String assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__c IN :spIds)AND FI_ASS_SEL_BusinessLine__c != \'03\' AND FI_ASS_SEL_BusinessLine__c != \'04\'';
        List<Asset> assets = database.query(assetQuery);
        assetQuery = getAssetsFields()+' (FI_ASS_LKP_Service_Point__c IN :spIds)AND (FI_ASS_SEL_BusinessLine__c = \'03\' OR FI_ASS_SEL_BusinessLine__c = \'04\')';
        List<Asset> assetsNE = database.query(assetQuery);
    //------

    Map<Id, List<Asset>> assetsWithSupplyPoint = new Map<Id, List<Asset>>();
    List<Asset> assetsWithoutSupplyPoint = new List<Asset>();
    for (Asset asset : assets) {
      if (asset.FI_ASS_LKP_Service_Point__c == null) {
        assetsWithoutSupplyPoint.add(asset);
      } else {
        if (
          !assetsWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)
        ) {
          assetsWithSupplyPoint.put(
            asset.FI_ASS_LKP_Service_Point__c,
            new List<Asset>()
          );
        }
        List<Asset> assetList = assetsWithSupplyPoint.get(
          asset.FI_ASS_LKP_Service_Point__c
        );
        assetList.add(asset);
        assetsWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetList);
      }
    }

     //--------ByFJDM
         Map<Id,List<Asset>> assetsNEWithSupplyPoint = new Map<Id,List<Asset>>();
        for (Asset asset : assetsNE) {
            if (asset.FI_ASS_LKP_Service_Point__c != null) {
                if (!assetsNEWithSupplyPoint.containsKey(asset.FI_ASS_LKP_Service_Point__c)) {
                    assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, new List<Asset>());
                }
                List<Asset> assetNEList = assetsNEWithSupplyPoint.get(asset.FI_ASS_LKP_Service_Point__c);
                assetNEList.add(asset);
                assetsNEWithSupplyPoint.put(asset.FI_ASS_LKP_Service_Point__c, assetNEList);
            }
        }
        //-------------


    Map<Id, Boolean> inProgressSupplyPointMap = getSupplyPointsAvailability(
      supplyPoints
    );

    Map<String, B2C_Service_Point__c> supplyPointsWithoutB2CAsset = new Map<String, B2C_Service_Point__c>();
    for (B2C_Service_Point__c supplyPoint : supplyPoints) {
      if (!assetsWithSupplyPoint.containsKey(supplyPoint.Id)) {
        supplyPointsWithoutB2CAsset.put(supplyPoint.Name, supplyPoint);
      }
    }

    Map<String, Integer> uspcMap;
    if (!supplyPointsWithoutB2CAsset.isEmpty()) {
      Set<String> uspcSet = supplyPointsWithoutB2CAsset.keySet();
      uspcMap = checkSupplyPointsInB2B(uspcSet);
    }
    return getTableRowWrapper(
      supplyPoints,
      uspcMap,
      assetsWithSupplyPoint,
      assetsWithoutSupplyPoint,
      inProgressSupplyPointMap,
      assetsNEWithSupplyPoint
    );
  }
}